# Coveo SearchInterface Component (CoveoSearchInterface)

## Index

### Methods

- attachComponent
- debugInfo
- detachComponent
- detachComponentsInside
- disable
- enable
- getBindings
- getComponents
- getQueryContext

### Properties

- disabled
- logger
- responsiveComponents
- ID

### Component Options

- allowQueriesWithoutKeywords
- autoTriggerQuery
- enableAutomaticResponsiveMode
- enableCollaborativeRating
- enableDebugInfo
- enableDuplicateFiltering
- enableHistory
- enableScrollRestoration
- excerptLength
- expression
- filterField
- firstLoadingAnimation
- hideUntilFirstQuery
- maximumAge
- modalContainer
- pipeline
- responsiveMediumBreakpoint
- responsiveMode
- responsiveSmallBreakpoint
- resultsPerPage
- searchPageUri
- timezone
- useLocalStorageForHistory

### Constructors

- constructor

## Methods

### attachComponent

- attachComponent(type: string, component: BaseComponent): void

- - Defined in ui/SearchInterface/SearchInterface.ts :617

  #### Parameters

  - ##### type: string

  - ##### component: BaseComponent

  #### Returns void

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  #### Returns any

### detachComponent

- detachComponent(type: string, component: BaseComponent): void

- - Defined in ui/SearchInterface/SearchInterface.ts :627

  #### Parameters

  - ##### type: string

  - ##### component: BaseComponent

  #### Returns void

### detachComponentsInside

- detachComponentsInside(element: HTMLElement): void

- - Defined in ui/SearchInterface/SearchInterface.ts :714

  #### Parameters

  - ##### element: HTMLElement

  #### Returns void

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  #### Returns void

### getBindings

- getBindings(): object

- - Defined in ui/SearchInterface/SearchInterface.ts :639

  #### Returns object

### getComponents

- getComponents<T>(type: string): T[]

- - Defined in ui/SearchInterface/SearchInterface.ts :693

  #### Type parameters

  - #### T

  #### Parameters

  - ##### type: string

  #### Returns T[]

### getQueryContext

- getQueryContext(): Context

- - Defined in ui/SearchInterface/SearchInterface.ts :665

  #### Returns Context

## Properties

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

### responsiveComponents

responsiveComponents: ResponsiveComponents

- Defined in ui/SearchInterface/SearchInterface.ts :528

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

## Component Options

### allowQueriesWithoutKeywords

allowQueriesWithoutKeywords: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :337

Markup configuration example(s) :

    data-allow-queries-without-keywords='true'
    data-allow-queries-without-keywords='false'

### autoTriggerQuery

autoTriggerQuery: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :321

Markup configuration example(s) :

    data-auto-trigger-query='true'
    data-auto-trigger-query='false'

### enableAutomaticResponsiveMode

enableAutomaticResponsiveMode: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :179

Markup configuration example(s) :

    data-enable-automatic-responsive-mode='true'
    data-enable-automatic-responsive-mode='false'

### enableCollaborativeRating

enableCollaborativeRating: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :377

Markup configuration example(s) :

    data-enable-collaborative-rating='true'
    data-enable-collaborative-rating='false'

### enableDebugInfo

enableDebugInfo: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :363

Markup configuration example(s) :

    data-enable-debug-info='true'
    data-enable-debug-info='false'

### enableDuplicateFiltering

enableDuplicateFiltering: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :388

Markup configuration example(s) :

    data-enable-duplicate-filtering='true'
    data-enable-duplicate-filtering='false'

### enableHistory

enableHistory: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :158

Markup configuration example(s) :

    data-enable-history='true'
    data-enable-history='false'

### enableScrollRestoration

enableScrollRestoration: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :488

Markup configuration example(s) :

    data-enable-scroll-restoration='true'
    data-enable-scroll-restoration='false'

### excerptLength

excerptLength: number

- Defined in ui/SearchInterface/SearchInterface.ts :212

Markup configuration example(s) :

    data-excerpt-length='10'

### expression

expression: string

- Defined in ui/SearchInterface/SearchInterface.ts :229

Markup configuration example(s) :

    data-expression='foo'

### filterField

filterField: IFieldOption

- Defined in ui/SearchInterface/SearchInterface.ts :246

Markup configuration example(s) :

    data-filter-field='@foo'

### firstLoadingAnimation

firstLoadingAnimation: HTMLElement

- Defined in ui/SearchInterface/SearchInterface.ts :312

### hideUntilFirstQuery

hideUntilFirstQuery: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :265

Markup configuration example(s) :

    data-hide-until-first-query='true'
    data-hide-until-first-query='false'

### maximumAge

maximumAge: number

- Defined in ui/SearchInterface/SearchInterface.ts :425

Markup configuration example(s) :

    data-maximum-age='10'

### modalContainer

modalContainer: HTMLElement

- Defined in ui/SearchInterface/SearchInterface.ts :510

### pipeline

pipeline: string

- Defined in ui/SearchInterface/SearchInterface.ts :403

Markup configuration example(s) :

    data-pipeline='foo'

### responsiveMediumBreakpoint

responsiveMediumBreakpoint: number

- Defined in ui/SearchInterface/SearchInterface.ts :441

Markup configuration example(s) :

    data-responsive-medium-breakpoint='10'

### responsiveMode

responsiveMode: "auto" | "small" | "medium" | "large"

- Defined in ui/SearchInterface/SearchInterface.ts :468

### responsiveSmallBreakpoint

responsiveSmallBreakpoint: number

- Defined in ui/SearchInterface/SearchInterface.ts :454

Markup configuration example(s) :

    data-responsive-small-breakpoint='10'

### resultsPerPage

resultsPerPage: number

- Defined in ui/SearchInterface/SearchInterface.ts :201

Markup configuration example(s) :

    data-results-per-page='10'

### searchPageUri

searchPageUri: string

- Defined in ui/SearchInterface/SearchInterface.ts :431

Markup configuration example(s) :

    data-search-page-uri='foo'

### timezone

timezone: string

- Defined in ui/SearchInterface/SearchInterface.ts :353

Markup configuration example(s) :

    data-timezone='foo'

### useLocalStorageForHistory

useLocalStorageForHistory: boolean

- Defined in ui/SearchInterface/SearchInterface.ts :188

Markup configuration example(s) :

    data-use-local-storage-for-history='true'
    data-use-local-storage-for-history='false'

## Constructors

### constructor

- new SearchInterface(element: HTMLElement, options?: ISearchInterfaceOptions, analyticsOptions?: any, _window?: Window): SearchInterface

- - Defined in ui/SearchInterface/SearchInterface.ts :536

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional options: ISearchInterfaceOptions

  - ##### Optional analyticsOptions: any

  - ##### Default value _window: Window = window

  #### Returns SearchInterface

### Implements

- IComponentBindings